Subject: Re: [MMUSIC] comments on draft-ietf-mmusic-sdp-g723-g729-03

From: "Parthasarathi R" <[email-masked]>
Date: Wed, 3 Jul 2013 22:58:59 +0530

Hi Aurelien,

Sorry for the delay response. Thanks for the review comments. 

Please read inline.

Thanks
Partha

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]
> Sent: Thursday, June 27, 2013 1:52 PM
> To: [email-masked]; [email-masked]; [email-masked]
> Subject: comments on draft-ietf-mmusic-sdp-g723-g729-03
> 
> Hi
> 
> I reviewed draft-ietf-mmusic-sdp-g723-g729-03 and I have some comments.
> They are quite symmetrical between G723 and G729.
> 
> 
> ** Section 3
> 
> 1)
> -----
>    Based on the above, it is best not to use comfort noise frames if
> the
>    SDP offer or answer indicates that comfort noise is not supported.
> -----
> The words "it is best not to use" are not strong enough, because it can
> not work if one of the party do not support comfort noise frames (SID
> frames in the ITU-T Annexes specs). It is rather a "MUST NOT use".
> 
> The word "restrict the use" in the RFC3551 quote is to be interpreted
> as "forbid the use".
> 
<Partha> It is fine. We will add this as a normative statement in case no
objection </Partha>

> 
> 
> ** Section 3.1
> 
> 2)
> After the first paragraph, I suggest to insert the new paragraph below:
> 
> ---NEW
>  The Annex A of the codec concerns both sending and receiving, so both
>  sides of a bi-directional session MUST have the same setting.  If
>  one party indicates that it does not support Annex A, Annex A  must be
>  deactivated both ways.
> -----
> That defines the general rationale of the following paragraphs.
>
<Partha> I agree with that it is the objective of this O/A requirement but
how this statement qualifies for normative statement is not clear. From the
offerer perspective, there is no control on same setting in both sides. In
case you look at the combine requirements of this draft, this object is met.
</Partha>
 
> 
> 3)
> -----
>    When the offer has G723 with annexa=no then the answer MUST NOT have
>    annexa=yes for G723.  Thus the annexa parameter can be turned off by
>    the answerer, but cannot be turned on.
> -----
> I don't think this new requirement is needed.
> Anyway implementation that will not implement this RFC-to-be will not
> comply with it.
> 
<Partha> As per based G723 RFC, it is expected for all the implementation to
support annexa. This issue is discussed in
http://www.ietf.org/mail-archive/web/mmusic/current/msg11165.html </Partha> 

> Plus, with the following paragraph, it breaks the equivalence between
> annexa=yes and annexa omitted.
> 
> Note that RFC3264 allows the SDP answer to include media format that
> are not present in the SDP offer, so it could be the same for the Annex
> A support.
> 
<Partha> RFC 3264 recommends to define offer/answer behavior per media
format whereas it is not defined for G723 & G729 and it is addressed as part
of this draft </Partha>

> 
> 4)
> -----
>    When the offer has G723 with annexa=no, the reason for not mandating
>    that the answer MUST have annexa=no for G723 is that there are there
>    implementations that omit the annexa parameter in answer and expect
>    the least common denominator to be used.
> -----
> 
> Add the following sentence at the end of the paragraph, to be explicit
> about the "least common denominator":
>    In such cases the offerer and answerer MUST proceed as if G723 is
>    negotiated with annexa=no.
> 
<Partha> Agreed. We will update the text </Partha>
> 
> 
> ** Section 3.2
> 
> 5)
> After the first two paragraphs, I suggest to insert the new paragraph
> below:
> 
> ---NEW
>  The Annex B of the codec concerns both sending and receiving, so both
>  sides of a bi-directional session MUST have the same setting.  If
>  one party indicates that it does not support Annex B, Annex B must be
>  deactivated both ways.
> -----
> That defines the general rationale of the following paragraphs.
> 

<Partha> Same as comment 2 reply. I agree with that it is the objective of
this O/A requirement but how this statement qualifies for normative
statement is not clear. From the offerer perspective, there is no control on
same setting in both sides. In case you look at the combine requirements of
this draft, this object is met. </Partha>

> 
> 6)
> -----
>    When the offer or answer has G729 and the annexb parameter is
> absent,
>    it MUST be considered as if the offer or answer has G729 with
>    annexb=yes.
> -----
> This paragraph is redundant with what is said before.
> Remove it.
> 
> 

<Partha> As per based G729 RFC, it is expected for all the implementation to
support annexb. This issue is discussed in
http://www.ietf.org/mail-archive/web/mmusic/current/msg11165.html </Partha>

> 7)
> -----
>    When the offer has G729 with annexb=no then the answer MUST NOT have
>    annexb=yes for G729.  Thus the annexb parameter can be turned off by
>    the answerer, but cannot be turned on.
> -----
> I don't think this new requirement is needed.
> For the same reason as for G723
> 
<Partha> Same reply as comment 3. As per based G729 RFC, it is expected for
all the implementation to support annexb. This issue is discussed in
http://www.ietf.org/mail-archive/web/mmusic/current/msg11165.html </Partha>

> 
> 8)
> -----
>    When the offer has G729 with annexa=no, the reason for not mandating
>    that the answer MUST have annexa=no for G729 is that there are there
>    implementations that omit the annexa parameter in answer and expect
>    the least common denominator to be used.
> -----
> 
> Replace annexa by annexb  (copy/paste error I guess)
> 
<Partha> Agreed </Partha>
> And add the following sentence at the end of the paragraph, to be
> explicit about the "least common denominator":
>    In such cases the offerer and answerer MUST proceed as if G729 is
>    negotiated with annexb=no.
> 
<Parta> Agreed </Partha>
> 
> 
> Best regards,
> Aurelien
> 
> 
> _______________________________________________________________________
> __________________________________________________
> 
> Ce message et ses pieces jointes peuvent contenir des informations
> confidentielles ou privilegiees et ne doivent donc
> pas etre diffuses, exploites ou copies sans autorisation. Si vous avez
> recu ce message par erreur, veuillez le signaler
> a l'expediteur et le detruire ainsi que les pieces jointes. Les
> messages electroniques etant susceptibles d'alteration,
> Orange decline toute responsabilite si ce message a ete altere, deforme
> ou falsifie. Merci.
> 
> This message and its attachments may contain confidential or privileged
> information that may be protected by law;
> they should not be distributed, used or copied without authorisation.
> If you have received this email in error, please notify the sender and
> delete this message and its attachments.
> As emails may be altered, Orange is not liable for messages that have
> been modified, changed or falsified.
> Thank you.

---

From: <[email-masked]>
Date: Thu, 4 Jul 2013 10:14:08 +0000

Hello

My answers inline
(I removed the agreed parts)

Aurelien

-----Message d'origine-----
De : Parthasarathi R [mailto:[email-masked]]
Envoyé : mercredi 3 juillet 2013 19:29
À : SOLLAUD Aurelien OLNC/OLN; [email-masked]; [email-masked] Objet : RE: comments on draft-ietf-mmusic-sdp-g723-g729-03

Hi Aurelien,

Please read inline.

Thanks
Partha

> Subject: comments on draft-ietf-mmusic-sdp-g723-g729-03

  (snip)
> sides of a bi-directional session MUST have the same setting.  If  one 
> party indicates that it does not support Annex A, Annex A  must be 
> deactivated both ways.
> -----
<Partha> I agree with that it is the objective of this O/A requirement but how this statement qualifies for normative statement is not clear. From the offerer perspective, there is no control on same setting in both sides. In case you look at the combine requirements of this draft, this object is met.
</Partha>

[Aurelien] OK. I agree you can turn "MUST" into "must". I think this new paragraph helps anyway.

> Anyway implementation that will not implement this RFC-to-be will not 
<Partha> As per based G723 RFC, it is expected for all the implementation to support annexa. This issue is discussed in http://www.ietf.org/mail-archive/web/mmusic/current/msg11165.html </Partha> 

[Aurelien] Yes I agree all implementations support annexa. What I called the RFC-to-be is the document draft-ietf-mmusic-sdp-g723-g729. My comment was that previous implementations will not comply with this "MUST NOT". A warning should be written on this. The receiver of the SDP should be tolerant and ready to receive SDP not compliant with this new requirement, without breaking.
I the offer has annexa=no and the answer (of an old implementation) has annexa=yes, Annex A must not be used.
It is the same kind of thing you describe later about the case where the offer has annexa=no and the answer has no annexa at all. Annex A must not be used.

  (snip)
> sides of a bi-directional session MUST have the same setting.  If  one 
> party indicates that it does not support Annex B, Annex B must be 
> deactivated both ways.
> -----

<Partha> Same as comment 2 reply. I agree with that it is the objective of this O/A requirement but how this statement qualifies for normative statement is not clear. From the offerer perspective, there is no control on same setting in both sides. In case you look at the combine requirements of this draft, this object is met. </Partha>

[Aurelien] same as comment 2, you can keep it informative and turn the "MUST" into "must".

> This paragraph is redundant with what is said before.

<Partha> As per based G729 RFC, it is expected for all the implementation to support annexb. This issue is discussed in http://www.ietf.org/mail-archive/web/mmusic/current/msg11165.html </Partha>

[Aurelien] You did not understand me. I said to remove the paragraph because it is an exact repetition of text. I quote the whole text:

----
   When the offer or answer has G729 and the annexb parameter is absent,
   the offerer or answerer knows that it has implied the default
   "annexb=yes".  This is because the annexb attribute is part of the
   original registration of audio/G729 [RFC4856].  All implementations
   that support G729 understand the annexb attribute.  Hence, this case
   MUST be considered as if the offer or answer has G729 with
   annexb=yes.

   When the offer or answer has G729 and the annexb parameter is absent,
   it MUST be considered as if the offer or answer has G729 with
   annexb=yes.
----

As you can see, the second paragraph says the exact same thing as the first one.

> For the same reason as for G723
<Partha> Same reply as comment 3. As per based G729 RFC, it is expected for all the implementation to support annexb. This issue is discussed in http://www.ietf.org/mail-archive/web/mmusic/current/msg11165.html </Partha>

[Aurelien] Same as comment 3, I suggest adding a warning on previous implementation that may not comply with this new requirement.

  (snip)

_________________________________________________________________________________________________________________________

Ce message et ses pieces jointes peuvent contenir des informations confidentielles ou privilegiees et ne doivent donc
pas etre diffuses, exploites ou copies sans autorisation. Si vous avez recu ce message par erreur, veuillez le signaler
a l'expediteur et le detruire ainsi que les pieces jointes. Les messages electroniques etant susceptibles d'alteration,
Orange decline toute responsabilite si ce message a ete altere, deforme ou falsifie. Merci.

This message and its attachments may contain confidential or privileged information that may be protected by law;
they should not be distributed, used or copied without authorisation.
If you have received this email in error, please notify the sender and delete this message and its attachments.
As emails may be altered, Orange is not liable for messages that have been modified, changed or falsified.
Thank you.